#include <stdlib.h>

#include "array.h"

int* create_tab(int tab[], unsigned tab_size) {
    tab = malloc(sizeof(int) * tab_size);
    if (tab != NULL) {
        /* initialize to zero the integer array */
        for (unsigned i = 0; i < tab_size; i++) {
            tab[i] = 0;
        }
    }
    return tab;
}

void free_tab(int tab[]) {
    free(tab);
}

/* we suppose both tabs are already created */
static void copy_tab(int src_tab[], int dest_tab[], unsigned src_tab_size, unsigned index_offset) {
    /* FIXME: I think it's worth doing some sanity checks on the array size:
     * dest_tab_size >= src_tab_size */
    for (unsigned i = 0; i < src_tab_size; i++) {
        dest_tab[i + index_offset] = src_tab[i];
    }
}

int* concat_tab(int tab1[], unsigned tab_size1, int tab2[], unsigned tab_size2, int tab_dest[]) {
    int* rt = create_tab(tab_dest, tab_size1 + tab_size2);

    copy_tab(tab1, tab_dest, tab_size1, 0);
    copy_tab(tab2, tab_dest, tab_size2, tab_size1);
    return rt;
}

int* resize_tab(int tab[], unsigned new_tab_size) {
    tab = realloc(tab, sizeof(int) * new_tab_size);
    return tab;
}

/* number of occurences of an element in an unsorted array  */
int count_tab_element(int tab[], unsigned tab_size, int element) {
    unsigned el_count = 0;
    for (unsigned i = 0; i < tab_size; i++) {
        if (tab[i] == element) {
            el_count++;
        }
    }
    return el_count;
}

void sort_tab(int tab[], unsigned tab_size, criteria_cb criteria) {
    sort_bubble_array(tab, tab_size, criteria);
}
